<!-- markdownlint-disable MD007 -->
<!-- markdownlint-disable MD033 -->
<!-- markdownlint-disable MD022 -->
<!-- markdownlint-disable MD041 -->
<!-- markdownlint-disable MD024-->
<!-- markdownlint-disable MD032-->
# Changelog

<a name="unreleased"></a>

## [Unreleased]


<a name="v2.9.0"></a>

## [v2.9.0]

2023-05-31

### Bug Fixes

- 优化编辑配置 
- 解决代码合并后的冲突问题 
- 编辑器重构，创建更新 
- 测试连接增加提示 
- 优化连接测试 
- 修复测试连接bug 
- Icon优化 
- 最新代码合并 
- 优化创建项目 
- change readme 
- 处理中英文 
- 代码优化 
- 修复配置文件展示异常bug 
- 优化json创建样式 
- 优化创建项目 
- **MTK:** invalid cross-device link 
- **MTK:** MTK Env Issue 
- **MTKD:** web format Parameter default value issue 
- **MTKD:** Modify the order in which the database connection is configured 
- **MTKD:** download table data error file issue 
- **MTKD:** connect mysql issue 
- **MVD:** Log data status issues 
- **MogDB:** Rewrite Oracle Package End Comment issue 
- **MySQL:** Foreign key constraint name and unique key constraint name of the same table are the same 
- **MySQL:** bit column default `b'0'` issue 
- **MySQL:** MySQL Driver Read Timeout issue 
- **MySQL:** Whether the query result column is null is different from the table definition 
- **MySQL:** date column default `curdate()` without parentheses questions 
- **Oracle:** PrintRowData panic when pureDriver is true 
- **Oracle:** Query Cons issue 
- **Oracle:** Check Cons is not null and column not null issue 
- **PLSQL:** rewrite oracle plsql new type issue 
- **PostgreSQL:** Query Cons index issue 
- **PostgreSQL:** Jsonb issue 
- **openGauss:** openGauss 5.0.0 charset keyword issue 

### Code Refactoring

- self upgrade 
- rename os.MkdirAll to write.createDir 

### Features

- **MTK:** add parameter `largeSequence` 
- **MTK:** parameter tableOptions/indexOptions support regexp 
- **MTK:** add usql support 
- **MTK:** upgrade support server url 
- **MTKD:** Refactor mtkd logging 
- **MVD:** add ENV TMP/TMPDIR 
- **MySQL:** Add MySQL timeout query 
- **MySQL:** Support Query MySQL 8.0 Check Cons 
- **Oracle:** upgrade go-ora driver to 2.7.4 
- **PLSQL:** convert-plsql supports partial table syntax 
- **SQLServer:** Support SQLServer 2016 

<a name="v2.8.5"></a>

## [v2.8.5]

2023-04-24

### Bug Fixes

- **MTK:** Oracle GBK Database clientCharset issue 
- **MTK:** command flag `disableCollStatistics` do not work 
- **MTK:** `channelCacheNum` issue 
- **MTK:** convert-plsql empty sql issue 
- **MTKD:** PreCheck failed without logging error message to database issues 
- **MTKD:** change Mediumtext to MediumBlob 
- **MVD:** Add Error Logfile info 
- **MogDB:** Rewrite `NUMTOYMINTERVAL(1 ，'MONTH')` issue 
- **MySQL:** MySQL STORED GENERATED issue 
- **Oracle:** Query Oracle Xmltype ORA-19011 
- **Oracle:** A table exists with the same name index under different db user 
- **Report:** Excel missing invalid failed number 
- **build:** mac osx file command issue 

### Code Refactoring

- **MTK:** Oracle ZHS16GBK Database clientCharset issue 
- **MySQL:** Reconnect to the database before querying table data. 

### Features

- **MTK:** Command flag overview config file issue 
- **MogDB:** Create View/function/procedure encountered an object that already exists with a modified status of warning 
- **MogDB:** Support uint1/uint2/uint4/uint8 column type 
- **MogDB:** For the Dolphin plugin, the original SQL is used first, and if the error is not already exist, it is created using the rewritten SQL 
- **MySQL:** Get a connection before inserting data 
- **Oracle:** Add DBLink Synonym Query 
- **Oracle:** xmlType force oracle fetchSize 50 issue 
- **Oracle:** Support Gen Create Bitmap Join index Syntax 
- **Oracle:** Add Charset warring info 
- **Oracle:** Query SQL support 9.2.0.4 
- **Report:** Excel report table data add src/tgt sql 

<a name="v2.8.4"></a>

## [v2.8.4]

2023-04-03

### Bug Fixes

- 优化运行日志 
- **Config:** Automatically adjust for `channelCacheNum` large issue 
- **DB2:** DB2 GBK Query Long VarGraphic/VarGraphic/Graphic issue 
- **DB2:** Mig DB2 GBK(GB18030) Data issue 
- **DB2:** Query DB2 GBK database issue 
- **MTK:** quoter add `=` 
- **MTK:** Rewrite trigger UPDATING('salary') issue 
- **MTK:** `convert-plsql` command Rewrite MySQL Trigger issue 
- **MTKD:** Stops the task but does not stop detail progress 
- **MTKD:** StartOperate merge issue 
- **MTKD:** update task result type status issue 
- **MTKD:** Concurrent migration source DB2 issues 
- **MTKD:** disable flush status to database logs write to table 
- **MTKD:** update task config issue 
- **MVD:** Parse MVD Version issue 
- **MVD:** license file some issue 
- **MogDB:** colMap Shared memory issues 
- **MogDB:** Rewrite OUTERJOIN Issue 
- **MogDB:** Rewrite `varchar(100CHAR)` issue 
- **MogDB:** Rewrite col default `('now'::text)::timestamp(3)` issue 
- **MogDB:** Sync Oracle sequence to large sequence issue 
- **MogDB:** Add function without parentheses call matching 
- **MogDB:** Rewrite `insert /*+ append */ into table alias` issue 
- **MogDB:** Rewrite `DBMS_OUTPUT.PUT_LINE` issue 
- **MySQL:** Query `bit(0)` issue 
- **MySQL:** ignore MySQL Create Constraint error `1061 (HY000): Duplicate key name` 
- **MySQL:** Rewrite to_char issue 
- **MySQL:** Query `bigint|int UNSIGNED` issue 
- **Oracle:** ignore index name recycleBin name 
- **Oracle:** go-ora driver query long some issue 
- **Oracle:** Remove default go-ora connect database 
- **PLSQL:** Rewrite insert into missing comment issue 
- **PLSQL:** Extract textValue issue 
- **PLSQL:** Extract comment issue 
- **PLSQL:** Rewrite slow issue 
- **PLSQL:** Rewrite `insert into comment table alias(column) values `issue 

### Code Refactoring

- Check Recycle Bin Object 
- **MTKD:** Flush Object to database 
- **Oracle:** extract regexp 

### Features

- add --license flag 
- **MTK:** `show-drop-cons` command add disable/fk flag 
- **MTK:** add parameter `skipExistPLSQL` configuration DDL will not include OR REPLACE 
- **MTK:** convert-plsql support flag --sep 
- **MTK:** add ColumnTypeData params 
- **MogDB:** Ignoring create package header already exists error 
- **MogDB:** disable rewrite listagg for mogdb 3.0.0 
- **MogDB:** add Oracle Constraint using index leading column Check 
- **MogDB:** Support 3.1.0 Dolphin Bigint UNSIGNED 
- **Oracle:** Query Oracle type SQL to add hint 
- **Oracle:** query func/proc/package add hint 
- **Oracle:** Query type/table/cons/view add hint 
- **openGauss:** openGauss 2.0.0 copy not support TRANSFORM issue 

<a name="v2.8.3"></a>

## [v2.8.3]

2023-03-13

### Bug Fixes

- **DB2:** try to fix An attempt to allocate a handle failed because there are no more handles to allocate 
- **DB2:** Optimize `timestamp` generation column query 
- **DB2:** CLI0129E An attempt to allocate a handle failed 
- **MTK:** Extract comment issue 
- **MTK:** config SCN does not take effect issue 
- **MogDB:** Create package no transactions 
- **MogDB:** Mig DB2 GBK to MogDB GBK issue 
- **MogDB:** Rewrite insert alias nologging issue 
- **MogDB:** Rewrite Comment issue 
- **MogDB:** Identify function issues without parentheses 
- **MogDB:** Remove rewrite `x = null` 
- **MogDB:** Create Partition Index with option syntax issue 
- **PLSQL:** Restore possible false positive constant replacement inside comment 

### Code Refactoring

- **MTK:** add getTaskList 
- **MogDB:** Optimize the constraint renaming logic 

### Features

- **MTK:** add task progress 
- **MTK:** When `igErrorData` is configured, SQL insert error messages are logged. Support Target is MySQL/MogDB/openGauss 
- **MTKD:** add mtkd sub command client 
- **MTKD:** add download report no error data 
- **MogDB:** Rewrite MySQL Create table like table 
- **MogDB:** update gb18030 charset 
- **MogDB:** Rewrite Oracle Create Type force syntax 

### Performance Improvements

- **MTKD:** Optimize Writer database performance 

<a name="v2.8.2"></a>

## [v2.8.2]

2023-02-23

### Bug Fixes

- **MTK:** Mig MySQL To MySQL Log the wrong number of rows issue 
- **MTK:** Comment alignment client character set 
- **MTK:** Mig Selects Trim SQL Suffix `;` 

### Features

- **MTK:** Support MySQL LINEAR HASH/KEY Partition 
- **MTKD:** Stop all running task by MTKD start 

<a name="v2.8.1"></a>

## [v2.8.1]

2023-02-20

### Bug Fixes

- **MTK:** self upgrade check db2 issue 
- **MTK:** Set the channel size to 1000 for tables with LOBs 
- **MTKD:** license flag redefine issue 
- **MogDB:** Mig Oracle Package Function with DETERMINISTIC issue 
- **MogDB:** Mig Oracle Function `return xx -- comment` issue 
- **MogDB:** remove add alias rewrite 
- **MySQL:** Support MySQL Collation (Database/Table/Column) 

### Code Refactoring

- comm.TranFunc replace reg to regStr 
- MogDB Check Col Default Support warring 
- add LoadAllTranslations/Tr/TrC/gin Language mid func 
- add survey lib 

### Features

- **MTK:** add parameter `customFuncTrans` 
- **MTK:** Modify the `channelCacheNum` default value to twice the `fetchSize` 
- **MTK:** add `ColumnNameData` params 
- **MTKD:** update task issue 
- **MTKD:** add `taskRunInfoMen` api 
- **MTKD:** add `/docs/mtk-parameter-desc` api 
- **MogDB:** Rewrite Oracle `update|delete return into` to `update|delete returning into` 
- **MogDB:** Mig Oracle unpaired block comment `/* /* /*` issue 
- **MySQL:** Migrate MySQL to MySQL hidden sequence types 
- **Oracle:** `enableCharTrimRightSpace` supports Oracle as the target 

<a name="v2.8.0"></a>

## [v2.8.0]

2023-02-06

### Bug Fixes

- 修复原因换行bug 
- 优化错误数据按钮文案 
- **MTK:** Ignoring that the number of rows is equal to the number of query rows status record is incorrect 
- **MTK:** Export timestamp with time zone to file missing time zone issue 
- **MTK:** parallelInsert docs issue and add GetParallelInsert method 
- **MogDB:** Mig DB2 Identity Column `ALTER [LARGE] SEQUENCE OWNER` issue 
- **MogDB:** Add Version check for set column type 
- **MogDB:** Mig Oracle BC DATA/TIMESTAMP issue 
- **Oracle:** insert data issue 
- **Oracle:** Mig MogDB Varchar length gt 4000 issue 
- **Oracle:** Mig MogDB Partition Table Issue 
- **Oracle:** Query Oracle Number(38,128) data precision problem when  pureDriver = true 
- **Oracle:** Mig `COL_XMLTYPE SYS.XMLTYPE` issue 
- **openGauss:** Rewrite insert into alias issue 

### Code Refactoring

- MogDB/PostgreSQL/openGauss get all extension 
- license 
- **MTK:** add unique method 

### Features

- **DB2:** Mig DB2 `float` to MogDB `real`, `double` to MogDB `double precision` 
- **MTK:** docgen add out type web 
- **MTK:** Simplify initialization project parameters, add --detail output full parameters 
- **MTKD:** Support MVD 
- **MogDB:** Create constraints and indexes Add object already exists error checks, if already exists is marked as a warning 
- **MogDB:** Add parameter `replaceBCDate` to support the 4173 BC time replace 
- **MogDB:** Support Dolphin Set Column type 
- **MogDB:** Mig Oracle `binary_float` to MogDB `real`, `binary_double` to MogDB `double precision` 
- **MogDB:** add params `ignoreTabPartitionTabList` 
- **MogDB:** noSupportPartTabToNormalTab supports partition key checking for virtual columns 
- **MogDB:** Support Rewrite DB2 timestamp DEFAULT "SYSIBM"."TIMESTAMP"(CURRENT TIMESTAMP) 
- **MogDB:** Migrate Oracle to MogDB/openGauss to lose virtual column information 
- **MySQL:** Modify `PK_ID `column primary key to unique key for `autoAddMySQLAutoIncr` 
- **openGauss:** `ignoreTabPartition` supports all databases 

<a name="v2.7.3"></a>

## [v2.7.3]

2022-12-26

### Bug Fixes

- **File:** Exporting to SQL files has no data issue 
- **Informix:** Query constraints and index column order issues 
- **MTK:** Convert PLSQL Unsupported types are not returned as unsupported 
- **MTK:** report-to-sql schema missing semicolon 
- **MTKD:** Run a task to reverse check issue 
- **MTKD:** PostgreSQL typo issue 
- **MTKD:** Error messages return problems 
- **MTKD:** Table field length issues 
- **MTKD:** The manual stop task is in the wrong status issue 
- **MogDB:** Mig PostgreSQL to MogDB A varchar type length does not increase 
- **PostgreSQL:** Mig MogDB BLOB data to PostgreSQL bytea data issue 
- **Report:** table label issue 
- **openGauss:** Mig DB2 Varchar for bit data issue 
- **openGauss:** Rewrite Oracle xxx.extend match error issue 
- **openGauss:** Mig PostgreSQL column default `nextval(xxx)` case sensitive issue 

### Code Refactoring

- Oracle scn definition. 
- Oracle scn definition. 
- extract mysql sql to sqltext 

### Features

- **MTK:** Convert PLSQL Support MySQL Trigger To MogDB 
- **MTK:** Add double quotation marks or backticks to the source SQL Statement 
- **MTK:** HTML report number add click effect 
- **MTK:** amd64 non-DB2 package convert-plsql supports DB2 to openGauss 
- **MTKD:** update mtkd web 
- **MTKD:** Add a task status check, delete the task does not allow the operation to be viewed 
- **MTKD:** Add parameters `--logo` support custom html report logo 
- **PostgreSQL:** Support MySQL RANGE partition to PostgreSQL 
- **Report:** Html report add database name display 
- **Report:** Excel report add dbName,dbHost,config 
- **SQLServer:** Support Query Table Partition Info 
- **SQLServer:** Support Query Table Size Info 
- **openGauss:** Support Mig SQLServer View To openGauss 
- **openGauss:** Support Mig SQLServer Geometry To openGauss 
- **openGauss:** Support Mig SQLServer GeoGraphy To openGauss 
- **openGauss:** Support for rewriting the Oracle trigger REFERENCING alias syntax 
- **openGauss:** Convert-plsql supports the rewriting of SQLServer views, functions, stored procedures to openGauss statements m-3103067 
- **openGauss:** Support Rewrite SQLServer Trigger To openGauss 
- **openGauss:** Add Query DB Params max_connections 
- **openGauss:** Add the parameter `enableGlobalIndexToLocal` to support the conversion of GLOBAL index to LOCAL index 

<a name="v2.7.2"></a>

## [v2.7.2]

2022-11-29

### Bug Fixes

- **MTK:** The table data comparison does not record SQL statements 
- **openGauss:** Mig BLOB data to bytea data issue 
- **openGauss:** Check version `3.0.3.6` issues when generating partition syntax 

<a name="v2.7.1"></a>

## [v2.7.1]

2022-11-28

### Bug Fixes

- **Informix:** Mig Column Type `interval second to fraction` data issue 
- **Informix:** Mig Informix interval data issue 
- **MTK:** remove AppendAliasClause from RewritePLSQL 
- **MTK:** Set Conn Max Idle Time issue 
- **MTK:** The user configuration character set is converted to uppercase 
- **MTK:** Object configuration schema/object/tables logic check 
- **MTK:** Auto Set clientCharset issue 
- **MTKD:** Gen Linux Service File some issue 
- **MTKD:** The download configuration file did not specify a file name 
- **MTKD:** Stop task run issue 
- **MogDB:** Mig Informix to MogDB col default some issue 
- **MySQL:** Rewrite MySQL GROUP_CONCAT to openGauss array_to_string/array_agg issue 
- **Oracle:** Rewrite Oracle Type VARRAY OF PLS_INTEGER issue 
- **Oracle:** Mig Oracle VARRAY Type Column data issue 
- **Oracle:** Column Type `Char(10 Char)` issue 
- **openGauss:** Mig Oracle Clob missing replace 0x00 
- **openGauss:** Create trigger syntax missing `;` 
- **openGauss:** Mig Mariadb/MySQL rewrite `current_timestamp()` issue 
- **openGauss:** Export File Missing `enableCharTrimRightSpace` 

### Code Refactoring

- **MTK:** replace zero date issue 
- **MTK:** Statistical index type 
- **openGauss:** Log error data file logic 
- **openGauss:** parameter `enableParallelIndex` control enables parallel index creation in openGauss/MogDB 

### Features

- **MTK:** Adapt to SqlServer 2012 
- **MTK:** Add index Statistic 
- **MTK:** Oracle external table migration is not supported 
- **MTK:** Add table/column Statistic 
- **MTK:** update  html report 
- **MTKD:** Add Subcommand gen service 
- **MTKD:** Get Task List add search params 
- **MTKD:** If the task has already been run, it is not allowed to modify the database type 
- **openGauss:** Upgrade driver supports copy to return error data 
- **openGauss:** Add Parameter `enableCharTrimRightSpace` 
- **openGauss:** Rewrite Oracle DBMS_UTILITY.format_error_backtrace to openGauss PG_EXCEPTION_CONTEXT 
- **openGauss:** Rewrite Oracle VARRAY Type to openGauss domain 
- **openGauss:** Add parameter Add `enableParallelIndex` control enables parallel index creation in openGauss/MogDB 

<a name="v2.7.0"></a>

## [v2.7.0]

2022-11-09

### Bug Fixes

- self upgrade Encountered control C termination issue 
- Duplicate data is inserted during the configuration of `igErrorData` 
- self upgrade some issue 
- **DB2:** MySQL Blob to DB2 issue 
- **DB2:** Rewrite NVARCHAR to Varchar(x CODEUNITS32) 
- **DB2:** create table syntax missing OCTETS 
- **MTK:** When remapSchema is configured, error message `xxx.xxx not existed` schema incorrect issue 
- **MTKD:** systemInfo some issue 
- **MTKD:** Gen templates ignore case 
- **MTKD:** openGauss connect issue 
- **MTKD:** Exception crash http 500 issues 
- **MySQL:** Mig Oracle Nvarchar to MySQL Nvarchar issue, change Nvarchar to varchar 
- **MySQL:** Mig openGauss to MySQL some issue 
- **Oracle:** Migrate type to openGauss to remove `authid current_user` syntax 
- **Oracle:** Mig Oracle Nvarchar to openGauss/MogDB issue 
- **Oracle:** Generate ora_hash split parallel statement issues 
- **SQLServer:** Mig SQLServer To MogDB Issue 
- **SQLServer:** Mig Sequence issue 
- **openGauss:** Exporting to a file does not verify time type data accuracy 
- **openGauss:** Generate xml type statement issues 
- **openGauss:** query column metadata missing timestamp precision 

### Code Refactoring

- connect timeout parameter 
- Optimize the output of configuration file error messages 
- **DB2:** new DB2 code 
- **MTK:** column char type 
- **MTK:** extract oracle to db2 colMap 

### Features

- **DB2:** Support MySQL Partition To DB2 Partition 
- **DB2:** add mysql to db2 col map 
- **MTK:** show-support-db add mogdb to db2 
- **MTK:** show-support-db add database 
- **MTK:** Add GaussDB for openGauss Primary/Standby version information adaptation 
- **MTK:** add params `dropSchema`. Prevent migration of a few tables and drop Schema with `dropExistingObject=true` 
- **MTKD:** run logs add run status filed 
- **MTKD:** Add the ID and creation time parameters to the log interface 
- **MTKD:** add template api interface 
- **MTKD:** task/GetTaskReportFile add post method and add runIDs body 
- **MTKD:** log add search params 
- **MySQL:** Mig MySQL Key Partition to MogDB Hash Partition 
- **Oracle:** auto add env `ORA_OCI_NO_OPTIMIZED_FETCH` 

<a name="v2.6.6"></a>

## [v2.6.6]

2022-10-20

### Bug Fixes

- **Oracle:** clob/blob user godror driver 
- **Oracle:** Disable the self-calculating lob field fetchSize 

### Code Refactoring

- **openGauss:** connect database 

<a name="v2.6.5"></a>

## [v2.6.5]

2022-10-17

### Bug Fixes

- **MTK:** If the table comment statement fails, modify the table status to Warning 
- **MTK:** The export file did not exit 
- **MTKD:** Object Finish Time is a negative number problem 
- **MTKD:** Updated database status is not timely and data loss issues 
- **MTKD:** resultTypes no Pagination 
- **MTKD:** getSchemas error info 
- **Oracle:** Add the package name when there is no definition of the package name in the package header end 

### Code Refactoring

- modify doUploadObject 

### Features

- **MTK:** cmd add group 
- **MTK:** Automatically recognizes the Oracle character set and sets the ClientCharset parameter 
- **MTKD:** Add the number of table data processing rows 
- **MTKD:** run results api add search 
- **Oracle:** Support Public Synonym 
- **openGauss:** disable auto create extension orafce 

### Performance Improvements

- update go-ora driver. Improves string conversion performance 
- Optimize Varchar data processing logic and reduce object allocation 
- **openGauss:** Optimized Performance 

<a name="v2.6.4"></a>

## [v2.6.4]

2022-10-08

### Bug Fixes

- **PostgreSQL:** bool type issue 
- **PostgreSQL:** Mig Oracle `minus` to `EXCEPT` 
- **PostgreSQL:** Mig Oracle function cursor issue 

### Features

- **MTK:** Update the license version and be compatible with the old version 
- **MTKD:** add tableOption `COLLATE=xxx_bin` for MySQL database 
- **MTKD:** swagger add https schema 
- **Oracle:** Support Oracle Flashback Queries. 
- **Oracle:** Support migrating bool/bit data to oracle 
- **openGauss:** Support some data types to migrate data to Oracle 

<a name="v2.6.3"></a>

## [v2.6.3]

2022-09-22

### Bug Fixes

- **MTK:** Export file error issue 
- **MTK:** Create foreign key constraint issue 
- **Oracle:** Mig Oracle Spatial data to file issue 
- **Oracle:** Mig Oracle trigger `after statement` issue 

### Performance Improvements

- **MySQL:** Optimized Migration to MySQL Performance 

<a name="v2.6.2"></a>

## [v2.6.2]

2022-09-21

### Bug Fixes

- **MTK:** File size mismatch when exporting file specified file size 
- **MySQL:** Mig MySQL varchar null issue 
- **Oracle:** Rewrite Oracle trigger `IF:NEW.ID` to openGauss issue 
- **Oracle:** Rewrite the last parameter of the function with comments issue 
- **Oracle:** Spatial Rectangle issue 
- **Oracle:** Mig Oracle `BINARY_DOUBLE` and `UDT` Data to openGauss issue 

### Code Refactoring

- **Oracle:** ColType to ColInfo 

### Performance Improvements

- **MTK:** Optimized record structure 

<a name="v2.6.1"></a>

## [v2.6.1]

2022-09-19

### Bug Fixes

- **MySQL:** Mig MySQL Blob Issue 

### Code Refactoring

- add pprof info print 

### Performance Improvements

- Optimize for loop 
- Optimize go-ora driver string conversion performance 

<a name="v2.6.0"></a>

## [v2.6.0]

2022-09-13

### Bug Fixes

- **MTK:** add rwLock for colType nil pointer issue 
- **MTK:** export csv missing file 
- **MTK:** csv file issue 
- **MTK:** Command line parameter precedence issue. 
- **MTK:** add subcommand license check 
- **MTKD:** convert-plsql some issue 
- **MySQL:** disable ANSI_QUOTES feature 
- **MySQL:** Mig MySQL set to PostgreSQL/openGauss/MogDB Varchar 
- **MySQL:** Query the view definition with show create view 
- **Oracle:** Pure Oracle driver number data issue. 
- **Oracle:** Mig Oracle Spatial To PostgreSQL/openGauss/MogDB issue 
- **PostgreSQL:** export csv file format issue 
- **PostgreSQL:** Mig Oracle To PostgreSQL/openGauss/MogDB  file issue 

### Code Refactoring

- **MTK:** Optimize the openGauss/PostgreSQL driver 
- **MTK:** extract cmd example 
- **PostgreSQL:**  StartWriteV2 and StartWriteCopyIn 

### Features

- **MTK:** `convert-plsql` add output flag 
- **MTK:** add self upgrade subcommand 
- **MTK:** add CheckTabExistCount1 Interface 
- **MTK:** cmd add gCMemPercent 
- **MTK:** show-table add detail flag 
- **MTK:** update example config 
- **MTKD:** Paging search supports pageNum/pageNo, pageLimit/pageSize 
- **MTKD:** add self upgrade 
- **MySQL:** Support MySQL Spatial Data Types 
- **MySQL:** Add `srs_id` for MySQL 8.0 column information 
- **Oracle:** Support Pure go oracle client `go-ora` 
- **Oracle:** Support Pure Golang Oracle Driver Read Data 
- **openGauss:** update keyword 
- **openGauss:** Support Local Socket Connect 

### Performance Improvements

- **MTK:** optimal performance 
- **MTK:** Optimize the progress of printing table data 
- **MTK:** Optimize export file performance 

<a name="v2.5.2"></a>

## [v2.5.2]

2022-08-30

### Bug Fixes

- **DB2:** Table name suffix with spaces in syscat.Columns view 
- **MTKD:** task run startTime and finishTime issue 
- **MySQL:** MySQL DSN `explicit_defaults_for_timestamp` some issue 
- **MySQL:** Mig MySQL Time Default issue 
- **MySQL:** mig `id BIGINT(20) unsigned AUTO_INCREMENT` to sequence owner by issue 
- **MySQL:** mig `id INT(10) unsigned AUTO_INCREMENT` to sequence owner by issue 
- **MySQL:** Add `binary` keyword to query constraint SQL 
- **openGauss:** Select Partition Syntax issue 

### Code Refactoring

- **MTKD:** update supportOperate api. change list to map 
- **MTKD:** convertSQLSupportType api 
- **config:** Extract configuration 

### Features

- **MTK:** add parameter `charLengthChangeExclude` 
- **MTK:** add mig-selects subcommand 
- **MTK:** Query Oracle NLS related parameters and save them to `otherParams` 
- **MTKD:** add task `getSchemas` api 
- **MTKD:** add operate api 
- **MTKD:** add merge taskRun api 
- **SQLServer:** Support trigger query 
- **SQLServer:** Support partial function/procedure syntax conversion to openGauss (beta) 
- **SQLServer:** Support function/procedure query 

<a name="v2.5.1"></a>

## [v2.5.1]

2022-08-16

### Bug Fixes

- **DB2:** Rewrite `insert into table_name values` 
- **MTKD:** typo SUCCESS -> Succeed 
- **Oracle:** Query Oracle Package Issue 

### Code Refactoring

- **MTKD:** Optimize db2 query table information logic 

### Features

- **MTK:** add `convertOracleIntegerToNumeric` Parameter 
- **MTK:** excludeTable add regexp support 
- **MTK:** mig-tab-data/sync-table-data add tableSplit flags 
- **MTK:** remove `convert-plsql`/`report-to-sql` hidden flag 
- **MTKD:** add `errorDataFile` api 

<a name="v2.5.0"></a>

## [v2.5.0]

2022-08-15

### Bug Fixes

- **DB2:** mig db2 view some issue 
- **MTK:** invalid object missing invalid msg 
- **MTK:** fix ColumnType nil pointer add CopyColumnType 
- **MySQL:** `DEFAULT_GENERATED ON UPDATE CURRENT_TIMESTAMP` issue 
- **Oracle:** VARRAY Type and type varchar2(10 char) 
- **Oracle:** `IOT_OVERFLOW` some issue 
- **Oracle:** rewrite view `AQ$_CBSD_CHREXX` issue 
- **Oracle:** rewrite `PIPE ROW` to `return next ();` issue 
- **Oracle:** Rewrite Oracle `SYS_EXTRACT_UTC` issue 
- **openGauss:** left join alias and procedure contain procedure issue 

### Code Refactoring

- **MTK:** Character set definition 
- **Oracle:** `authid current_user` syntax 
- **RDBMS:** SetConnMaxLifetime to SetConnMaxIdleTime 

### Features

- **MTK:** add convertTypeMethod feature 
- **MTK:** add excel report file 
- **MTK:** add convert-plsql subcommand 
- **MTK:** report-to-sql subcommand support convert html report to excel 
- **MTKD:** add unwrapper api 
- **MTKD:** add convert sql api 
- **MTKD:** add systemInfo 
- **MTKD:** add report and log download 
- **Oracle:** Query view/function/procedure objectID 
- **Oracle:** Support unwrapper charset convert 
- **Oracle:** Rewrite Oracle `commit work` to openGauss `commit` 
- **Oracle:** Support unwrapper procedure/function/package 
- **openGauss:** Support charset Decode 
- **openGauss:** Migrate Oracle Package to openGauss 3.0 Package 

### Performance Improvements

- **Oracle:** Optimize Oracle query view performance 

<a name="v2.4.4"></a>

## [v2.4.4]

2022-08-01

### Bug Fixes

- gosec some issue 
- **MySQL:** generate mysql ddl script some issue 
- **MySQL:** mig MySQL double to openGauss some issue 
- **config:** Remove config object convert to Upper 
- **openGauss:** create view missing commit 

### Code Refactoring

- select column aliases Add as syntax. 
- **MySQL:** Optimize DB2 auto-increment columns and migrate to MySQL auto-increment columns 
- **Oracle:** Rewrite the query Type SQL statement 

### Features

- Add select column aliases Add as syntax. beta 
- **MySQL:** Support foreign keys reference index 
- **MySQL:** Support mysql bit to mysql bit 
- **Oracle:** Support oracle type body rewrite. beta 
- **mtkd:** add preCheck API 
- **mtkd:** task run add reason 
- **openGauss:** support column serial add `ALTER  SEQUENCE seq_name OWNED BY table_name.column_name` 

<a name="v2.4.3"></a>

## [v2.4.3]

2022-07-18

### Bug Fixes

- **Oracle:** Rewrite sequence.nextval/currval in Oracle Package 
- **Oracle:** Rewrite decode with comment issue / table(xx) alias issue 
- **Oracle:** Rewrite Oracle trigger `into:new.id` to openGauss issue 
- **Oracle:** Convert Oracle number(*,2) to openGauss NUMERIC(2,2)issue 
- **Oracle:** Rewrite Oracle type to openGauss `varchar2 (4000)` issue 
- **mtk:** special comment syntax 
- **openGauss:** Single table column duplicate issue 
- **openGauss:** Create view not set search_path 
- **openGauss:** Do not dump synonym defined by package 

### Code Refactoring

- **Oracle:** Rename postgres to postgresql 
- **file:** Generate sql file 
- **openGauss:** parse database version 
- **plsql:** convert object type 

### Features

- **MySQL:** Support column extra `on update current_timestamp` to mogdb 3.0 B mode 
- **MySQL:** Support converting MySQL double-quote constants into single-quote constants. 
- **Oracle:** Rewrite `extend` function as a comment 
- **Oracle:** openGauss/MogDB 3.0.0 does not convert the `decode` function 
- **Oracle:** Support MogDB and openGauss functions and return when there is an out parameter 
- **Oracle:** Rewrite oracle `table(` to openGauss `UNNEST(` 
- **Oracle:** Rewrite part of the writing of new type 
- **Oracle:** openGauss/MogDB 3.0.0 does not convert package header `:=` to `default` 
- **Oracle:** Add User Privilege Check 
- **Oracle:** Support more new type syntax rewriting 
- **mtk:** Support encrypt password 
- **mtk:** Add invalid failed num statistics 
- **openGauss:** Add keyword `VERIFY` 
- **openGauss:** modify openGauss default version 3.0.0 
- **openGauss:** Support query MogDB 3.0.0 columns on update property `on update current_timestamp` 
- **openGauss:** For MogDB/openGauss 3.0.0 ignore sequence.nextval rewrite 
- **openGauss:** Support query create type as table of 
- **openGauss:** Support query openGauss table of type 

<a name="v2.4.2"></a>

## [v2.4.2]

2022-07-04

### Bug Fixes

- **MySQL:** Delay catching commit errors 
- **MySQL:** batchCommit ignore error data issue 
- **Oracle:** Rewrite Package without package body 
- **Oracle:** Rewrite the problem of defining float/number type in the package 
- **Oracle:** mig package to openGauss some issue 
- **Oracle:** mig oracle type to openGauss some issue 
- **Oracle:** mig package to openGauss some issue 

### Features

- **MySQL:** add long_query_time default connect parameter. default 36000 
- **Oracle:** support oracle column udt type 
- **Oracle:** support table of type 
- **Oracle:** rewrite Oracle `PIPELINED` to PostgreSQL `setof` 

<a name="v2.4.1"></a>

## [v2.4.1]

2022-06-24

### Bug Fixes

- **Oracle:** tab missing primary key columns 
- **db2:** Constrained repetition issue 
- **mtkd:** task_result_details sequence issue 

### Code Refactoring

- **db2:** get index method 

### Features

- **MTK:** enable informix 
- **db2:** Add some object ObjectID query 
- **mtk:** support mysql/og/mogdb/pg batchCommit 

### Performance Improvements

- **MySQL:** support batchSize commit 
- **db2:** Optimize Convert float64 to string 
- **db2:** Optimize Convert TimeDuration To OraInterval 

<a name="v2.3.5"></a>

## [v2.3.5]

2022-06-20

### Features

- **informix:** support informix 

### Performance Improvements

- **mtk:** Optimize processing time data performance 

<a name="v2.3.4"></a>

## [v2.3.4]

2022-06-20

### Bug Fixes

- **MySQL:** mig mysql function to openGauss rewrite if then syntax issue 
- **MySQL:** mig MySQL to openGauss DatCompatibility B empty string convert " " issue. and DatCompatibility B does not need to modify the column length 
- **Oracle:** object name with $ sign 
- **Oracle:** rewrite oracle mod to openGauss mod 
- **Oracle:** remove Extra Parenthesis issue 
- **Oracle:** There is no query table partition information in dataOnly mode, resulting in no data migration 
- **mtk:** excludeTable issue 
- **openGauss:** ignore create extension orafce error 

### Features

- **Oracle:** return error when function|procedure contain function|procedure 
- **mtk:** add params disablePrintMigDataProgress disable table data Progress print 
- **mtk:** report add table query data SQL 
- **openGauss:** support batchSize commit 

### Performance Improvements

- **mtk:** Optimize the performance of table synchronization data 

<a name="v2.3.3"></a>

## [v2.3.3]

2022-06-09

### Bug Fixes

- 优化结果展示，解决sql复制bug 
- **MTK:** skipColumnName issue 
- **MySQL:** MySQL ignores case query constraints where conditional issues 
- **Oracle:** mig Oracle raw to openGauss raw issue 
- **docgen:** delete dstdocgen 
- **mtkd:** create/update/run task add config check 
- **mtkd:** update gorm to v1.23.1 and modify SetConnMaxIdleTime 
- **openGauss:** rewriting the insert statement with alias causes the normal insert rewrite error issue 
- **test:** unit test issue 

### Code Refactoring

- **mtkd:** http logs 
- **openGauss:** error msg convert 

### Features

- **Oracle:** remove oracle function declaration PARALLEL_ENABLE 
- **Oracle:** rewrite oracle deterministic to openGauss IMMUTABLE 
- **mtkd:** add connect pool params 
- **openGauss:** add timestamp precision warning 
- **openGauss:** support oracle ST_GEOMETRY to geometry 
- **openGauss:** rewrite oracle wmsys.wm_concat to wm_concat 
- **openGauss:** rewrite oracle ! = to openGauss != 

<a name="v2.3.2"></a>

## [v2.3.2]

2022-05-16

### Bug Fixes

- **MySQL:** The table primary key syntax does not convert keyword issues 
- **Oracle:** mig oracle number to openGauss/mysql issue number/number(*,0)->int/number(20) 
- **openGauss:** convert db2 `current user` to openGauss `session_user` 

### Features

- **mtk:** add parameter `convertNumberToBigint` support convert not specified precision number(Number(*,0)/Number) to bigint 
- **openGauss:** support add/modify/delete index options 
- **openGauss:** support add/modify/delete table options 

<a name="v2.3.1"></a>

## [v2.3.1]

2022-05-09

### Bug Fixes

- **DB2:** mig to mysql identity column to move to the primary key to the first column 
- **MTKD:** default log level debug issue 
- **MySQL:** mig oracle number(19<p<38) to mysql Decimal missing p issue 
- **MySQL:** Get table auto increment column value not close database connection 
- **openGauss:** mig oracle number(*,0) to openGauss Decimal missing p issue 
- **openGauss:** query partition key sql issue 

### Code Refactoring

- **MTK:** extract version and database new 
- **MTKD:** Extract the http layer code 

### Features

- **MTKD:** Supports collect os stats save nodes. --collectOsStat/--collectOsInterval 
- **MySQL:** support mig trigger to openGauss/MogDB 
- **Postgre:** support GENERATED ALWAYS AS IDENTITY 
- **openGauss:** support og 3.0 large sequence 

<a name="v2.3.0"></a>

## [v2.3.0]

2022-04-19

### Bug Fixes

- **DB2:** mig db2 to mysql table column name with tab. example " COL1\t" -> " col1". 
- **DB2:** The DB2CODEPAGE environment variable is not set without exiting the program 
- **DB2:** mig db2 to mysql BLOB, TEXT, GEOMETRY or JSON column can't have a default value issue 
- **DB2:** mig db2 to mysql table column name with blank. example " COL1 " -> col1 
- **MTKD:** rename deleteUserId to deletedUserId,updateUserId to updatedUserId 
- **MTKD:** replace c.BindJSON(userOP) to c.ShouldBindWith(userOP, binding.JSON). disable gin auto write 400 code 
- **MTKD:** task reset api 400 issue 
- **MySQL:** Views contain Chinese conversion issues 
- **MySQL:** convert interval syntax issue 
- **MySQL:** Replace set error when both the update statement and the set variable exist in the procedure 
- **MySQL:** no conversion some functions issue 
- **MySQL:** rewrite view join issue 
- **MySQL:** rewrite convert to cast syntax issue 
- **Oracle:** No procedure name problem defined at the end of procedure in package 
- **Oracle:** colKeyWords weighting issues 
- **Oracle:** mig Oracle to MySQL tab/col name with space/tab issue 
- **Oracle:** rewrite insert with return keyword syntax issue 
- **Oracle:** mig package to og package missing comment 
- **Oracle:** Conversion procedure parameters with comment syntax issues 

### Code Refactoring

- **MTK:** Gets the object name method 

### Features

- **DB2:** Support db2 date/time column default current date/time to mysql current_date/time 
- **MTKD:** task table add password slat. 
- **MTKD:** Password encrypted storage 
- **MySQL:** Syntax conversion is supported for functions without begin 
- **MySQL:** convert comment # to -- 
- **Oracle:** replace all_ view to dba_ view 
- **Oracle:** disable convert %rowtype to record. openGauss 2.0.0 support %rowtype 
- **Oracle:** Create Table syntax support type 
- **Oracle:** Support convert %rowtype to record 
- **Oracle:** Support convert insert alias syntax 
- **Oracle:** Convert Chinese `（），` to English 
- **openGauss:** remove default check_function_bodies=off 

<a name="v2.2.5"></a>

## [v2.2.5]

2022-04-11

### Bug Fixes

- **MTK:** useTime issue 
- **MariaDB:** In version 10.3.9 column default values issues 
- **MariaDB:** query index issue 
- **MariaDB:** remove explicit_defaults_for_timestamp set 
- **Oracle:** convert to_clob issue 
- **Oracle:** No Column length changes for Char(1) 
- **Oracle:** The column default sequence name contains the $ symbol. 
- **Postgres:** mig postgis geometry data issue 
- **Postgres:** query function issue 
- **Postgres:** drive issue 

### Features

- **MTK:** add SetConnMaxLifetime and upgrade go 1.17 
- **MTKD:** add SetConnMaxLifetime 
- **MTKD:** table task add node_id 
- **MTKD:** add node info 
- **MTKD:** add userId 
- **Oracle:** convert binary_integer to integer 
- **Oracle:** convert pls_integer to integer 
- **Oracle:** add parameter `convertPackageMethod` support mig package to openGauss package. 
- **openGauss:** The connection string add the parameter check_function_bodies=off settings 

### Performance Improvements

- **MTK:** Generate reports using time and memory 
- **MTK:** Optimize data query performance and memory inuse 

<a name="v2.2.4"></a>

## [v2.2.4]

2022-03-25

### Bug Fixes

- mtkd query syntax issue 
- oracle query table size sql statement is missing the condition 
- db2 get generated column seq owner nil issue 
- oracle table statistics syntax 
- **openGauss:** 2.1.0 COPY does not support sub transactions or exceptions 

### Code Refactoring

- create table error code add sql 
- mtkd 

### Features

- support db2 TIMESTAMP NOT NULL GENERATED ALWAYS FOR EACH ROW ON UPDATE AS ROW CHANGE TIMESTAMP 
- datCompatibility add ora/mysql 
- **Oracle:** The package does not have a package body definition to return success issues 
- **Oracle:** remove procedure `authid current_user` syntax 
- **Postgres:** support mig postgis to openGauss 
- **mtkd:** support mysql database 
- **mtkd:** add api configFile download config file 

<a name="v2.2.3"></a>

## [v2.2.3]

2022-03-15

### Bug Fixes

- COPY does not support subtransactions or exceptions for openGauss/MogDB 2.0.0 
- Creating a table comment encountered error 22021 
- mig oracle package to openGauss end package_name issue 

### Code Refactoring

- parse openGauss/MogDB version info 
- changed chartset to charset 

### Features

- add query parameter 
- show-table-split add ora_hash method for oracle database 
- add parameter charAppendEmptyString to ORA-29275 
- when migrating to an openGauss UTF8 database, forced transcoding occurs when the string encoding is not UTF8 
- add param clientCharset IgErrorData 

<a name="v2.2.2"></a>

## [v2.2.2]

2022-03-01

### Bug Fixes

- code specifications and security issues 
- mig oracle to mysql some issue 
- mig Oracle to MogDB 2.1.0 some syntax conversion issue 
- db2 clob length issue 
- show-drop-index some issue 
- mysql ignores case table names as well issue 

### Code Refactoring

- postgres/openGauss rename index/cons name 

### Features

- added a query to see if the orafce extension is installed 
- Disable connect by conversion when migrating to mogdb 2.1.0 
- Optimized the migration of Oracle to openGauss constrained renaming logic 
- Oracle Table Data Check add character set encoding check 

<a name="v2.2.1"></a>

## [v2.2.1]

2022-01-21

### Bug Fixes

- mysql show create table error issue 
- mig to oracle ORA-00911 error 
- mig to oracle object name length gt 30 issue 
- oracle sequence the number of values to CACHE must be greater than 1 
- quoteMark parameter does not take effect issue 
- mig db2 to mysql cons issue 
- mig db2 to mysql index name and constraint name length greater than 64 issue 
- mig sqlserver to mysql columt type conversion issue 
- mysql connect string issue 
- mig db2 GENERATED IDENTITY column to mysql auto_incr column, primary key column order issue 

### Features

- Add parameter disableFKCons support disabling foreign key constraint sync 
- add parameter autoAddMySQLAutoIncrTabList 

<a name="v2.2.0"></a>

## [v2.2.0]

2022-01-11

### Bug Fixes

- 修复问题行数展示增加单位问题 
- mig db2 to og converts procedure end p1 issue 
- mig db2 to og converts procedure and functions missing the package attribute 
- mysql CREATE_OPTIONS/DATA_LENGTH null issue 
- mysql CREATE_OPTIONS null issue 
- mysql engine null issue 
- mig og to og some issue 
- add mysql date/datetime year=0 check 
- mig db2 view gen create view syntax issue 
- mig openGauss column default null issue 

### Code Refactoring

- Query the openGauss index opClass logic 

### Features

- add db2/oracle/ table data check 
- support openGauss/mogdb subpartition 

<a name="v2.1.6"></a>

## [v2.1.6]

2021-12-29

### Bug Fixes

- disable mysql query view INNODB_TABLESTATS 
- command parallel default values to 1 
- mig og to og partition/constrains query issue 
- mig db2 to mysql alter_sequence issue 
- db2 timestamp max precision 
- db2 driver slice bounds out 
- mig openGauss index add opClass 
- mig-tab-post no collect statistical information issues 
- mig db2 pl/sql some syntax conversion issues 

### Code Refactoring

- sql.ColumnType to models.ColumnType 

### Features

- disable the parallel query table partitioning feature 
- add parameter templateSeqName 
- add mig-select subcommand 
- MySQL query sequences add show create table 
- support openGauss partition index 
- add show-drop-index/cons subcommand 

<a name="v2.1.5"></a>

## [v2.1.5]

2021-12-11

### Bug Fixes

- tableDataEst crash issue 
- migration db2 index column order issues 
- mig openGauss query constrains issue 

<a name="v2.1.4"></a>

## [v2.1.4]

2021-12-10

### Bug Fixes

- mig mysql auto_incr column query issue and add seqLastNumAddNum flags 
- mig oracle column default issue 

### Features

- add skip table column types and table column names 

<a name="v2.1.3"></a>

## [v2.1.3]

2021-12-08

### Bug Fixes

- mig mysql view crash issue 

### Code Refactoring

- some regexp issue 

<a name="v2.1.2"></a>

## [v2.1.2]

2021-12-06

### Bug Fixes

- mysql partition key expressions UNIX_TIMESTAMP issue 
- convert mysql timestampdiff, isnull, str_to_date function issue 
- mtk report index sum issue 
- mig function lost when the function name same 
- warring message table exited issue 
- mig mysql text empty string not null to openGauss text ' ' 
- mig mysql procedure hang issue 
- mig mysql datetime to openGauss timestamp(0) 
- mig sequence issue. force the migration of all sequences 
- mig mysql column default empty string issue 

### Code Refactoring

- convert mysql date_format function format style 

### Features

- supports mysql limit syntax conversion 
- support mysql 5.1.73 
- Improve migration date/datetime(n)/timestamp(n) to openGauss timestamp(n) precision issues 

<a name="v2.1.1"></a>

## [v2.1.1]

2021-11-29

### Bug Fixes

- db2 codepage issue 
- Migration db2 on windows, environment variable db2codepage settings issues 
- mig db2 to openGauss procedure overrides issue 
- mig openGauss blob to openGauss blob issue 
- query postgres table size issue 
- query postgres schema issue 
- support 9.7 same query issue 
- supports the migration of DB2 to MySQL to auto add auto-incr columns, only for tables that do not have auto-incr columns 
- windows timezone info issue 
- support oracle identity column 
- mig db2 to og cursor definition syntax issues 
- mig db2 Vargraphic to mysql varchar 
- mig oracle to mysql partition high_value include timestamp issue. 
- Migration db2 function to openGauss last statement missing semicolon issue 

### Code Refactoring

- show-xx subcommand print result 
- format sql 
- update support version 

### Features

- support mysql invisible column 
- mig xmltype/xml to mogdb xml 
- support db2 9.7 
- add init-project subcommand and add parameters autoAddMySQLAutoIncr 
- update db2 support tips 

<a name="v2.1.0"></a>

## [v2.1.0]

2021-11-23

### Bug Fixes

- mig db2 function to openGauss STATIC DISPATCH/SPECIFIC S.X syntax 
- mig db2 view with check option and with row movement syntax issue 
- oracle spatial null issue 
- table,column comment with char(0) issue 
- mig oracle spatial to postgis some issue 
- query oracle package statement issue 
- column is named rownum,timestamp issue 

### Code Refactoring

- rename directory 

### Features

- support convert oracle spatial to postgis 
- fk constraints are created concurrently according to the main table 
- update openGauss system column names keyword list 
- update openGauss keyword list 
- support mig oracle/db2 blob/clob to openGauss blob/clob. Controlled by parameters `enableOgBlobClob` 
- Migration overview increases sorting 

<a name="v2.0.0"></a>

## [v2.0.0]

2021-11-15

### Bug Fixes

- mig db2 col timestamp default format issue 
- mig oracle function index to openGauss issue 
- convert mysql date_format function format to openGauss format problem 

### Code Refactoring

- add columnBool and table data skip temp table ,add rdbms RecoverErr 

### Features

- mig db2 table data to db2,csv,sql 
- support mig db2 to db2 (beta) 
- support db2 user mapping and nickname 

<a name="v0.0.41"></a>

## [v0.0.41]

2021-11-06

### Bug Fixes

- mig mysql datetime error data issue. 

<a name="v0.0.40"></a>

## [v0.0.40]

2021-11-05

### Bug Fixes

- mig oracle table excretion materialized views 
- mig DB2 specifies a table loss sequence issue 
- mig mysql view if syntax causes the MTK to enter a dead loop 
- mig mysql view if syntax causes the MTK to enter a dead loop 
- postgres StartWriteCopyIn add recovery 
- unit test write error 
- mtk run add PreCheck 

### Features

- support mig db2 server 
- support mig db2 wrapper 
- support oracle mview query 
- ignore case query. upper(col_name) = strings.ToUpper(xx) 
- remapSchema,remapTable,remapTablespace ignore case 
- add a test migration data feature 

<a name="v0.0.39"></a>

## [v0.0.39]

2021-10-25

### Bug Fixes

- mig oracle varchar(10 char) length issue 
- oracle view with read only syntax 
- db2 show tables slow issue. 
- db2 charset issue. add env DB2CODEPAGE check 
- Concurrent creation of indexing and constraint issues, modified to create concurrently by table 
- db2 function/procedure truncate syntax and update set syntax 
- mig og to og function,procedure some issue 
- update license 

### Code Refactoring

- replace openGauss driver 
- RemoveUnusedDoubleFlag 

### Features

- add trace 
- db2 adds the calculated compression table size 
- add error and warring text report 
- support text report 
- Overriding query statements supports migrating some objects 
- when migrating to openGauss, the minvalue partition is automatically converted to maxvalue partition 
- supports partial og-to-oracle table structure migration 
- support mig openGauss package to openGauss package 

<a name="v0.0.38"></a>

## [v0.0.38]

2021-10-08

### Bug Fixes

- mig db2 to openGauss interval expression 
- mig db2 to openGauss values expression problems. ignore insert into xx values xx 
- mig mysql auto-incr column to openGauss sequence +1 issue 
- migration og constraint issues 
- mig openGauss to openGauss some issue 
- openGauss query sequence slow issue 
- csv format issue. 
- migration db2 partition to the openGauss as a range partition of the varchar/timestamp type 

### Code Refactoring

- Compare two Version numbers 

### Features

- add sql script file serial number when exported to file 
- add generate mysql `LOAD DATA INFILE XX INTO TABLE` 
- initial support for db2 procedure migration to openGauss 
- initial support for db2 function migration to openGauss 
- update the licensing mechanism 
- support postgres/openGauss virtual column 
- support migration pg rule to og 
- support migration pg base type to og 

<a name="v0.0.37"></a>

## [v0.0.37]

2021-09-24

### Bug Fixes

- og DatCompatibility missing b-mode check 
- db2 virtual identity column sequence is always zero 
- seq MINVALUE=MAXVALUE issue 
- db2 query view ADMINTABINFO slow 
- mig db2 to og partition issue 
- mysql query statement case issue 
- mig pg to og procedure syntax cannot be used directly 
- postgres some issue 

### Code Refactoring

- write file code 
- partition code 
- resolves the results of the mysql to_days/from_days function 
- not support msg 

### Features

- support migration pg mview to og 
- add the db2 procedure function trigger sql syntax 
- supports migration of db2 materialized views to og 
- support mig mysql to_days/year/unix_timestamp range partition table to openGauss 
- postgres/openGauss support type migrate 
- support postgres/openGauss domain query 

<a name="v0.0.36"></a>

## [v0.0.36]

2021-09-17

### Bug Fixes

- mysql 8.0.23 query information_schema.INNODB_TABLESTATS issue 
- calculate table-level parallel migration task is complete issue. 
- migration db2 to og loss of constraints issue 
- the default value is missing in the migration to openGauss 

### Code Refactoring

- generate create table statement 

### Features

- support i18n 
- support query openGauss function/procedure/view/trigger 
- add error data logging 
- add parameter autoAddMaxvaluePart to auto add maxvalue partition 
- add parameter file to support quick export to file 
- support migration to postgres 

<a name="v0.0.35"></a>

## [v0.0.35]

2021-09-13

### Bug Fixes

- add parameter ignoreTabPartition to support ignoring table partition syntax when creating a table 
- mig db2/oracle timestamp column type to mysql datetime(6) 

<a name="v0.0.34"></a>

## [v0.0.34]

2021-09-06

### Bug Fixes

- mig oracle view trigger function to og syntax problem 
- inaccurate reporting time 
- export data to file failure caused by refactor code 
- remapSchema failure caused by refactor code 
- 优化sql展示，取消格式化操作 
- 修复版本重复展示的问题 

### Code Refactoring

- create table,index 
- modify command description and op/pg error info 

### Features

- resolve the object name length is greater than 64 
- update report style 
- support MariaDB 5.5.62 
- check mysql version and regenerate the connection string to reconnect 

<a name="v0.0.33"></a>

## [v0.0.33]

2021-08-31

### Bug Fixes

- quote add special characters 
- mig to og/mogdb/pg replace dual to sys_dummy 
- chinese character gash issue. 
- recover panic issue 
- oracle show create sql add quoter 
- search_path is wrong when creating the view/function/procedure/trigger 
- column names contain brackets and percent signs and add QuotePartColName func 
- table name constraint name index name consistency problem 
- 修补编译bug，降低压缩插件版本；增加版本展示 
- no warning message when the table exists when the table is created 
- MySQL 8.0 view information_schema.TABLES auto-increment column is inaccurate, left related view information_schema.INNODB_TABLESTATS query 
- mysql function no begin issue 
- db2 query schema and table issue 
- mig mysql to og mysql show sequences sql issue 

### Code Refactoring

- query table related methods 
- generate create table statement 
- remove QuoteToColName function 
- Extract version info and report add version info 
- modify mysql schema(database) query 

### Features

- sync table data add table exist check 
- support ignoring db2 system tables. adding parameters excludeSysTable can be customized by users 
- after synchronizing table data, create an index and cons without waiting for the synchronization of all table data 
- add collect table statistics 
- support mysql set enum col type to opengauss 
- add parameters EnableSyncTabTbsPro/RemapTbsSpace to support tablespace conversion 
- db2 show create table statement supports compression and organize by 
- db2 connect string add ClientApplName,ProgramName info 
- ignore case when mig mysql database/schema 

<a name="v0.0.32"></a>

## [v0.0.32]

2021-08-25

### Bug Fixes

- eslint compression plugins 升级 

<a name="v0.0.31"></a>

## [v0.0.31]

2021-08-25

### Bug Fixes

- table data estimate time issue 
- db2 VarGraphic issue 
- 升级axios 
- oom issue 
- header样式优化 
- db2 to og csv some issue. 
- security issues 

### Features

- support sync db2 Column Generated Always Id to mysql auto incr 
- oracle add auto check the env NLS_LANG and set it 
- add the default log in the same directory as reportFile 

<a name="v0.0.30"></a>

## [v0.0.30]

2021-08-18

### Bug Fixes

- constraint names same issue 
- db2 timestamp col default value format issue. 2019-01-10-10.52.08.554035 
- mig oracle to mysql some issue 
- mig oracle index column with desc to mysql issue. 

<a name="v0.0.29"></a>

## [v0.0.29]

2021-08-13

### Bug Fixes

- convert oracle trim to trim(both xx) and dbms_lock.sleep to pg_sleep 
- mig db2 table data to mysql insert syntax issue 
- mig db2 part table to mysql some issue 
- mysql create constraint does not support using index,change to normal syntax 
- db2 sequence migration to mysql shows success,change failed 
- generating terminal report is slow 
- procedure convert to og some issue 

### Features

- support migrate oracle package to og schema.procedure/function. (alpha beta version) 
- add mig-tab-pre/data/post/other subcommand 
- support oracle trigger mig to openGauss 

<a name="v0.0.28"></a>

## [v0.0.28]

2021-08-09

### Bug Fixes

- split table add abs function because mod function will appear negative. 
- migrating to og is missing package parameters in functions and stored procedures 
- mysql incr column convert to og sequence, sequence schema miss remap 
- mysql auto-increment column migration to og sequence cache changed to 1 
- mysql set parameters to prevent automatic addition of default value syntax to timestamp column 
- mysql connection string time zone problem. default local 

### Code Refactoring

- extract the code 
- extract the code 

### Features

- support convert db2 some date function to opengauss 
- add gen auto complete shell 
- support connect by rewriting (alpha beta version) 
- support db2 migration to mysql 
- og copy support batchSize 

<a name="v0.0.27"></a>

## [v0.0.27]

2021-08-02

### Bug Fixes

- replace oracle add_years function issue 
- Auto skip the view auto created by the system when DB2 creates a functional index 
- mysql add query sql_mode params 
- add panic recover capture 
- Added missing UTF-8 charset definitions 
- convert oracle function to opengauss some issue 
- mysql 8.0 query view issue 
- mysql column default 0000-00-00 00:00:00, migrate to og rewrite 1970-01-01 
- ignore mysql Column prefix index. (custom_condition(100) 
- Rewrite MySQL JOIN with WHERE clause instead of ON 
- When db2 creates a constraint, the constraint name and the index name are inconsistent 

### Code Refactoring

- extract keyword definition 
- Extract the code 
- Optimized some show commands 

### Features

- support oracle synonym db2 alias to og synonym 
- auto skip db2 nickname view 
- support rewrite mysql xxx cursor for to og cursor xxx is 
- support rewrite mysql join syntax but there is no on or using related conditions 
- support oracle NLSSORT convert to og collate syntax 
- replace oracle function months_between 
- add oracle/mysql related function conversion, support rewrite oracle rownum and oracle outer join + 
- Using regular expressions support for migrating oracle procedure to og. (alpha beta version) 

<a name="v0.0.26"></a>

## [v0.0.26]

2021-07-23

### Bug Fixes

- configuration file error does not print the error message 
- mysql constraint with the same name problem 
- mysql text pq: invalid byte sequence for encoding "UTF8": 0x00 
- db2 virtualColConv ignore case 
- mysql bigint unsigned auto incr issue, function/procedure query issue 
- table names with Spaces 
- When migrating the constraints of db2 to og, first create a unique index and then create a constraint 
- mysql index sub part custom_condition(1000) to og substring(custom_condition,0,1000) 
- db2 function index 
- mysql int unsigned to bigint 
- mysql 8.0 DEFAULT_GENERATED issue 

### Code Refactoring

- rename plugin to databases 

### Features

- Using regular expressions support for migrating oracle functions to og. (alpha beta version) 
- try to convert oracle type syntax 
- remove db2 col default "SYSIBM"."BLOB"(''), 
- support mysql bit column type 

<a name="v0.0.25"></a>

## [v0.0.25]

2021-07-19

### Bug Fixes

- code smells 
- gen copy sql missing db2 virtual identity column 
- oracle 11g deferred_segment_creation. Change the show table size to left join 
- report startTime and finishTime order issue 

### Code Refactoring

- mtk parallel scheduling code 
- optimize report 
-  Adjust migration order 

### Features

- add remove/restore comment code 
- add interval type regular matching 
- add parameters virtualColConv to allow users to customize virtual column conversion And try automatic regular replacement 
- add alter sequences ,modify the start value of the sequence 
- automatically skip db2 virtual column check constraints 
- add gen-config subcommand 
- db2 auto skip nickname table index 

<a name="v0.0.24"></a>

## [v0.0.24]

2021-07-16

### Bug Fixes

- postgres multi-column partitioning key problem 
- No double quotes are added to the column at the beginning of the number 

### Code Refactoring

- add gen.go file auto generate sync_object.go 
- Optimize the code 

### Features

- add mysql/db2 table split 
- openGauss add Virtual column syntax 
- support sqlServer view to openGauss/MogDB 
- support sqlServer index to openGauss/MogDB 
- show-schema add the display schema size 
- support sqlServer constraint to openGauss/MogDB 
- add subcommand check-config to check the correctness of the configuration file 
- Add subcommands to migrate specific types of database objects 
- postgres support secondary partition 
- add sub command showSchema,showTopTableSize,showTopTableSplit 
- add showTopTables Parameter display Top20 table size 
- support sqlserver schema and tableData to og、MogDB 
- oracle add select parallel 

<a name="v0.0.23"></a>

## [v0.0.23]

2021-07-07

### Bug Fixes

- db2 partition sorting problem 

### Features

- add sqlserver identity column 
- add sqlserver table query 
- support sqlserver sequence to og/mogdb 

<a name="v0.0.22"></a>

## [v0.0.22]

2021-07-02

### Bug Fixes

- mysql character length migrated to og length is * three 
- program did not exit normally 
- column length has not changed when exporting the file 
- windows report 
- select case issue. table_name is "T_t1" 

### Code Refactoring

- Optimize the code 

<a name="v0.0.21"></a>

## [v0.0.21]

2021-06-30

### Bug Fixes

- Migrate all views under the oracle user and remove filter conditions 

### Code Refactoring

- Optimization constraint creation 

### Features

- Oracle adds display triggers creation statements 
- Oracle adds display functions, stored procedures, and package creation statements 

### Performance Improvements

- Optimize concurrent lock 
- Optimize the performance of table synchronization data 

<a name="v0.0.20"></a>

## [v0.0.20]

2021-06-22

### Bug Fixes

- db2 xml include XML version and encoding add XMLDeclaration=1 
- db2 dbClob to og text 

<a name="v0.0.19"></a>

## [v0.0.19]

2021-06-18

### Bug Fixes

- oracle range partition table has two partition column 
- oracle/db2/mysql '' and null issues. 
- db2 connect 

<a name="v0.0.18"></a>

## [v0.0.18]

2021-06-16

### Bug Fixes

- db2 GBK CHARSET Database char include chinese error slice bounds out of range 
- mtkd html icon 
- 创建迁移bug 
- db connect not release 
- 修复bug 增加级别过滤 
- mtkd http some issue 
- mtkd some issue 
- report finishTime 
- some mtkd issue 
- oracle '' = null to migrate openGauss is not null issue 
- mysql time issue. mysql year to openGauss int 
- oracle/mysql 0x00 issue 
- db2/mysql blob/clob issue 
- 移除无用代码，增加全局过滤 
- oracle clob blob data issue 
- Modify query oracle dblink view . replace all_db_links to dba_db_links 
- add oracle long raw column type 
- openGauss add Col Key Word stream. convert to "STREAM" 
- missing column length from query openGauss/postgres database. 
- migrate oracle missing table 
- table ddl comp CHAR = CHARACTER/VARCHAR = CHARACTER VARYING 

### Code Refactoring

- rewrite mtkd 

### Features

- mtkd add license 
- support non-utf8 charset migration to openGauss/MogDB utf8 automatically change length 
- support estimated oracle/mysql table data migrate time 
- mtkd preRunResults preRunResultTypes 
- mtkd start 
- add mtkd 
- support dameng database to openGauss 
- config add colKeyWords、objKeyWords configuration parameter 
- new html report 
- support db2 partition level parallelism and Customize parallel conditions and new html report 
- support oracle/mysql partition level parallelism and Customize parallel conditions 
- Support pre-check mode. cmd params --preRun 
- support db2 trigger/function/procedure query and count 
- add oracle Procedure/Function/Trigger Type query and count. and fix unit test 
- add oracle Procedure/Function/Package/Synonym/DBLink/Queue Type query and count 
- support openGauss 2.0.0 
- openGauss add get database datcompatibility 

<a name="v0.0.17"></a>

## [v0.0.17]

2021-03-25

### Bug Fixes

- add table ddl basic compare. colName and number/varchar length 
- modify split mysql 8.0 partition expression 
- db2 expoter ddl to file skip name existed check 
- modify mysql blob to openGauss bytea 
- modify mysql/db2 blob to openGauss text 
- db2 miss select GENERATED ALWAYS AS IDENTITY column 
- time miss s flag 
- replace postgres database driver, db2 for bit data ,tableDataComp add status 
- db2 cons include tid column to openGauss issue. convert to "TID" 
- cons tgtSQL missing 
- openGauss auto rename cons name 
- create view regular expression support AS ( 
- sqlDBType set issue. Only user Settings when the target.type is file 
- add openGauss cons name check if name exited name auto + 1 
- db2 view as ( to openGauss 
- db2 timestamp current timestamp to og current_timestamp 
- oracle  number(38,127)/number(38,-84) to openGauss 
- oracle global temporary table to openGauss global temporary table 
- mysql partition table index to openGauss local index. and og get partition issue 

### Code Refactoring

- column define type 
- rename mtk.logger to l 
- modify mssql const name 

### Features

- new html report 
- support mysql view to openGauss 
- oracle plug support query 10g 
- add params mySQLSkippErrorDateTimeData. auto skip row include Wrong time '0000-00-00 13:14:15' 
- support mysql auto_incr to openGauss big serial and set big serial seq next values = auto_incr num 
- support db2 export openGauss csv format file 
- db2 GENERATED ALWAYS/DEFAULT AS IDENTITY to openGauss col default NEXTVAL(seq) 
- add param mySQLToOgCharExpression 
- add table data select count comp 

<a name="v0.0.16"></a>

## [v0.0.16]

2021-03-05

### Bug Fixes

- mysql to openGauss miss Multi-column  PRIMARY KEY 
- replace timezone Asia/Beijing to Asia/Shanghai 
- mig mysql to og index name already exists 
- mysql get constraint ignore PRIMARY KEY 
- modify oracle blob to openGauss text 

### Code Refactoring

- remove unused code 
- modify db2 generate dsn 

### Features

- support mysql partition to openGauss. and fix some bug 
- Replace openGauss database driver 
- support db2 view to openGauss, but limited by dv2 sql syntax 
- add Errors map[string]error 
- support db2 virtual column query 
- support db2 GLOBAL TEMPORARY TABLE to openGauss 
- Support openGauss 1.1.0 hash/list partition 
- Support DB2 index to openGauss 
- Support DB2 constrains to openGauss 
- Support DB2 table data to openGauss 
- Support for DB2 table partition 
- Support for DB2 table column queries 

### Performance Improvements

- Optimize query performance. buildRecord 

<a name="v0.0.15"></a>

## [v0.0.15]

2021-02-18

### Bug Fixes

- set search_path before create view 
- set search_path before create view 
- Oracle query index ignore pk index 

### Features

- Adapt MySQL to OpenGauss 

<a name="v0.0.14"></a>

## [v0.0.14]

2021-01-07

### Bug Fixes

- parse openGauss version 1.1.0 
- connect postgres bug 
- index out of range 

### Code Refactoring

- replace postgre driver pgx to pq 

<a name="v0.0.13"></a>

## [v0.0.13]

2020-11-10

### Bug Fixes

- remove openGauss and postgres cons disable syntax 
- Tables, constraints, indexes ignore recycle bin objects.BIN$ 
- object status. The specific object status is success and failed. task and object type task status is finish and failed 
- add mysql keyword include - 
- add oracle col default sysdate/systimestamp convert to mysql/pg current_timestamp 
- oracle2mysql some bug 

### Code Refactoring

- 重构创建序列.增加部分数据库修改当前值.测试数据提取 

### Features

- Add command parameters bufferSize、cpBufferSize、batchSize 
- Add command parameters caseSensitive 
- support oracle column default seq nextval to openGauss/postgres 
- support db2 sequence 
- add db2 get schema 

### Performance Improvements

- Improve openGauss Sync data performance 

<a name="v0.0.12"></a>

## [v0.0.12]

2020-10-12

### Bug Fixes

- check upload server http/https 
- tableData missing temporary table 
- stop return success when task not existed 
- fix colMap Capitalization issues 

### Features

- support oracle local index sync openGauss local index 
- 1.add get oracle index partition 2.add oracle get system/Reference partition table 3.use ydoc to generate documentation 

<a name="v0.0.11"></a>

## [v0.0.11]

2020-09-29

### Bug Fixes

- add get mysql index 
- fix cfgCheck bug 

### Features

- add postgres table partition 
- add mysql get index 
- add postgres table partition 
- add mysql get constraint 
- add openGauss and postgres export data to file 

<a name="v0.0.10"></a>

## [v0.0.10]

2020-09-24

### Code Refactoring

- move openGauss create object type to postgres 

### Features

- add postgres and openGauss get sequence and support sync to mysql/oracle/openGauss/postgres. 
- add postgres and openGauss get index and support sync to mysql/oracle/openGauss/postgres. add partition unit test add postgres remove ::text keyword. 

<a name="v0.0.9"></a>

## [v0.0.9]

2020-09-23

### Features

- add postgres and openGauss get constrain and support to mysql/oracle/openGauss/postgres 
- The password must be cipher text under http server 
- add schema and connTest api interface. 

<a name="v0.0.8"></a>

## [v0.0.8]

2020-09-21

### Code Refactoring

- replace pflag to go-flags 
- add http server run and rewrite cmd execute 

### Features

- add docker build 
- mtk add http server start. support precheck,run,stop api interface 

<a name="v0.0.7"></a>

## [v0.0.7]

2020-09-17

### Code Refactoring

- rewrite metadata 
- rewrite start writer 

### Features

- Add a parameter noSupportPartTabToNormalTab. Convert unsupported partition table to normal table. remove unsupported Sub partition attribute. 
- Convert Oracle interval(NUMTOYMINTERVAL(1,'year')) syntax to interval(1 year) 

<a name="v0.0.6"></a>

## [v0.0.6]

2020-09-16

### Bug Fixes

- pq: invalid byte sequence for encoding "UTF8": 0x00 replace \u0000 to "" 
- dataOnly not sync data 2. fix postgres query table bug 3. add debug log 
- 1. fix dataOnly not sync data 

### Features

- oracle to openGauss object type 
- oracle to openGauss range partition 

<a name="v0.0.5"></a>

## [v0.0.5]

2020-09-15

### Features

- Support Oracle View To MySQL 

<a name="v0.0.4"></a>

## [v0.0.4]

2020-09-15

### Code Refactoring

- 增加部分mysql同步 
- 重构生成sql语句返回error 
- 重构部分oracle代码增加获取oracle分区信息 

### Features

- Support Oracle List、Hash、Range Partition To Postgres 
- Oracle2OpenGauss增加视图 
- Oracle2OpenGauss增加索引同步 

[Unreleased]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.9.0...HEAD
[v2.9.0]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.8.5...v2.9.0
[v2.8.5]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.8.4...v2.8.5
[v2.8.4]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.8.3...v2.8.4
[v2.8.3]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.8.2...v2.8.3
[v2.8.2]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.8.1...v2.8.2
[v2.8.1]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.8.0...v2.8.1
[v2.8.0]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.7.3...v2.8.0
[v2.7.3]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.7.2...v2.7.3
[v2.7.2]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.7.1...v2.7.2
[v2.7.1]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.7.0...v2.7.1
[v2.7.0]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.6.6...v2.7.0
[v2.6.6]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.6.5...v2.6.6
[v2.6.5]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.6.4...v2.6.5
[v2.6.4]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.6.3...v2.6.4
[v2.6.3]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.6.2...v2.6.3
[v2.6.2]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.6.1...v2.6.2
[v2.6.1]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.6.0...v2.6.1
[v2.6.0]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.5.2...v2.6.0
[v2.5.2]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.5.1...v2.5.2
[v2.5.1]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.5.0...v2.5.1
[v2.5.0]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.4.4...v2.5.0
[v2.4.4]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.4.3...v2.4.4
[v2.4.3]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.4.2...v2.4.3
[v2.4.2]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.4.1...v2.4.2
[v2.4.1]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.3.5...v2.4.1
[v2.3.5]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.3.4...v2.3.5
[v2.3.4]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.3.3...v2.3.4
[v2.3.3]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.3.2...v2.3.3
[v2.3.2]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.3.1...v2.3.2
[v2.3.1]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.3.0...v2.3.1
[v2.3.0]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.2.5...v2.3.0
[v2.2.5]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.2.4...v2.2.5
[v2.2.4]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.2.3...v2.2.4
[v2.2.3]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.2.2...v2.2.3
[v2.2.2]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.2.1...v2.2.2
[v2.2.1]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.2.0...v2.2.1
[v2.2.0]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.1.6...v2.2.0
[v2.1.6]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.1.5...v2.1.6
[v2.1.5]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.1.4...v2.1.5
[v2.1.4]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.1.3...v2.1.4
[v2.1.3]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.1.2...v2.1.3
[v2.1.2]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.1.1...v2.1.2
[v2.1.1]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.1.0...v2.1.1
[v2.1.0]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v2.0.0...v2.1.0
[v2.0.0]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.41...v2.0.0
[v0.0.41]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.40...v0.0.41
[v0.0.40]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.39...v0.0.40
[v0.0.39]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.38...v0.0.39
[v0.0.38]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.37...v0.0.38
[v0.0.37]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.36...v0.0.37
[v0.0.36]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.35...v0.0.36
[v0.0.35]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.34...v0.0.35
[v0.0.34]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.33...v0.0.34
[v0.0.33]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.32...v0.0.33
[v0.0.32]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.31...v0.0.32
[v0.0.31]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.30...v0.0.31
[v0.0.30]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.29...v0.0.30
[v0.0.29]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.28...v0.0.29
[v0.0.28]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.27...v0.0.28
[v0.0.27]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.26...v0.0.27
[v0.0.26]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.25...v0.0.26
[v0.0.25]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.24...v0.0.25
[v0.0.24]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.23...v0.0.24
[v0.0.23]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.22...v0.0.23
[v0.0.22]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.21...v0.0.22
[v0.0.21]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.20...v0.0.21
[v0.0.20]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.19...v0.0.20
[v0.0.19]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.18...v0.0.19
[v0.0.18]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.17...v0.0.18
[v0.0.17]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.16...v0.0.17
[v0.0.16]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.15...v0.0.16
[v0.0.15]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.14...v0.0.15
[v0.0.14]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.13...v0.0.14
[v0.0.13]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.12...v0.0.13
[v0.0.12]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.11...v0.0.12
[v0.0.11]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.10...v0.0.11
[v0.0.10]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.9...v0.0.10
[v0.0.9]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.8...v0.0.9
[v0.0.8]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.7...v0.0.8
[v0.0.7]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.6...v0.0.7
[v0.0.6]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.5...v0.0.6
[v0.0.5]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.4...v0.0.5
[v0.0.4]: http://gitlab.enmotech.com/mogdb_en/mtk/compare/v0.0.1...v0.0.4
